package ucl.salinization.displays;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Paint;
import java.awt.Stroke;

import repast.simphony.space.graph.RepastEdge;
import repast.simphony.visualization.visualization2D.style.EdgeStyle2D;


public class ScenarioNetStyle2D implements EdgeStyle2D {

	/**Edge 2D style*/
	int directedTargetEnd = EdgeStyle2D.ARROW_HEAD;

	/**
	 * Method to get the color
	 * @param actorID the actor/agent's id
	 * @return
	 */
	private Paint getActorColor(String actorID){
    Paint color = null;
    
    if (actorID.equals("Russia"))
		  color = Color.RED;
    else if (actorID.equals("Afghanistan"))
		  color = Color.GREEN;
    else
    	color = Color.BLUE;
		
		return color;
	}
	
	/**
	 * Method to get the pain for an edge
	 * @param edge the edge object
	 */
	public Paint getPaint(RepastEdge edge) {
	
//		Step target = (Step)edge.getTarget();
//		Step source = (Step)edge.getSource();
		
//		if (target.isHighlighted())
//				return Color.ORANGE; 
		
//    return getActorColor(target.getActorID());
	  return Color.RED;
	}

	/**
	 * Method to get the stroke size
	 * @param edge the edge object
	 */
	public Stroke getStroke(RepastEdge edge) {
//		Step target = (Step)edge.getTarget();
	
		// TODO set based on support level
		
		int size = 2;
		return new BasicStroke(size);
	}

	public void setPaint(Paint paint) {
  }

	public void setStroke(Stroke stroke) {
	}

	public Paint getSourceEndPaint(RepastEdge edge) {
    return getPaint(edge);
	}

	public int getSourceEndStyle(RepastEdge edge) {
		return EdgeStyle2D.NULL_HEAD;
	}

	public Paint getTargetEndPaint(RepastEdge edge) {
		return getPaint(edge);
	}

	/**
	 * Method to get target end style
	 * @param edge the edge object from a network
	 */
	public int getTargetEndStyle(RepastEdge edge) {
		if (edge.isDirected()) {
			return directedTargetEnd;
		}
		return EdgeStyle2D.NULL_HEAD;
	}
}
