package ucl.salinization.displays;

import java.awt.Color;

import repast.simphony.visualization.gis3D.Material;
import repast.simphony.visualization.gis3D.MaterialFactory;
import repast.simphony.visualization.gis3D.MultiLine;
import repast.simphony.visualization.gis3D.PolygonShape;
import repast.simphony.visualization.gis3D.RenderableShape;
import repast.simphony.visualization.gis3D.style.StyleGIS3D;


/**
 * 
 * @author
 *
 */
public class StateStyle implements StyleGIS3D<State>{

	public RenderableShape getShape(State state) {

//		if (state.getName().contains(AgentNameConstants.FIELD_NAME))
//		  return new PolygonShape();
//		else
		  return new MultiLine();

	}

	public Material getMaterial(State state, Material material) {

		if (material == null) 
			material = new Material();

		float alpha = 1.0f;
		
		Color color;
//		if (state.getName() == null)
//			color	= new Color(1,1,1,alpha);
		
		if (state.getName().equals(""))
			color	= new Color(1,1,0,alpha);
		else if (state.getName().equals("Tajikistan NW"))
			color	= new Color(0.6f,1,0,alpha);
		else if (state.getName().equals("Tajikistan SW"))
			color	= new Color(0,1,0,alpha);
		else if (state.getName().equals("Tajikistan E"))
			color	= new Color(1,0,0,alpha);
		else if (state.getName().equals("Russia"))
			color	= new Color(1,0,0,alpha);
		else if (state.getName().equals("Afghanistan"))
			color	= new Color(0,1,0,alpha);
		else
			color	= new Color(1,1,1,alpha);
		
		MaterialFactory.setMaterialAppearance(material, color);

		return material;

	}

	public float[] getScale(State state) {
		return null;
	}

	public boolean isScaled(State state) {
		return false;
	}
}