package ucl.salinization.style;

import com.vividsolutions.jts.geom.Point;

import gov.nasa.worldwind.awt.WorldWindowGLCanvas;
import gov.nasa.worldwind.geom.LatLon;
import gov.nasa.worldwind.render.Renderable;
import repast.simphony.space.gis.Geography;
import repast.simphony.visualization.gis3D.StyledMapLayer3D;
import repast.simphony.visualization.gis3D.WWUtils;
import repast.simphony.visualization.gis3D.style.StyleGIS3D;


/**
 * Style layer based on StyledMapLayer3D in Repast Visualization, which uses WW.
 * @author
 *
 */
public class GeoStyleLayer extends StyledMapLayer3D{
	Geography geography;
	boolean population;
	
	public GeoStyleLayer(String name,StyleGIS3D s, WorldWindowGLCanvas wwglCanvas) {
		super(name,s, wwglCanvas);
	}

/*	protected v createVisualItem(Object o) {
//		PNode node = style.getPNode(o, null);
//		node.setPaint(style.getPaint(o));
//		node.setBounds(style.getBounds(o));
//		node.addAttribute(COORD_KEY, new Point2D.Double(0, 0));

		LatLon point = WWUtils.CoordToLatLon(((Point)geography.getGeometry(o)).getCoordinate());

		Renderable node=null;

//		node = new SurfaceCircle(model.getGlobe(), point, 5e4, 30, 
//		new Color(0f, 1f, 1f, 0.3f), new Color(0.5f, 1f, 1f, 0.8f), null);

//		if(o instanceof Person){
//			node = new WWSphereFERAL(point,10,"person");
//		}
//		else if (o instanceof Community)
//			node = new WWSphereFERAL(point,10,"community");
		
		visualItemMap.put(o, node);
		// style.getStroke()
		return node; 
	}*/
	
	protected void applyUpdatesToNode(Renderable node) {
	
//		Object o = node.getAttribute(AGENT_KEY);

		// TODO originally the node attributes were first stored and
		//      then set here, but it seems that the attributes
		//      can be read directly from the style
//		node.setPaint((Paint) node.getAttribute(PAINT_KEY));
//		((PPath)node).setStroke((Stroke) node.getAttribute(STROKE_KEY));
//		((PPath)node).setStrokePaint((Paint) node.getAttribute(STROKE_PAINT_KEY));
//		((PPath)node).setBounds(((Rectangle2D) node.getAttribute(BOUNDS_KEY)));

//		Paint paint = style.getPaint(o);
//		if (!paint.equals(node.getPaint())) node.setPaint(paint);

//		Rectangle2D bounds = style.getBounds(o);
//		tmpBounds.setRect(bounds);
//		if (!node.getBounds().equals(tmpBounds)) node.setBounds(bounds);

//		if (node instanceof PPath) {
//		((PPath) node).setStroke(style.getStroke(o));
//		((PPath) node).setStrokePaint(style.getStrokePaint(o));
//		}

//		if (style.getLabel(o) != null) {
//		node.removeAllChildren();
//		node.addChild(style.getLabel(o));
//		}

//		double scale = 0;
//		if (!style.isScaled(o))
//		scale = 1 / canvas.getCamera().getViewScale();

//		else if (scale != 0)
//		node.setScale(scale);

		// update the location if changed from previous and repaint node
//		Point2D oldPoint = node.getOffset();
//		Point2D newPoint = (Point2D) node.getAttribute(COORD_KEY);

//		if (newPoint != null && oldPoint.distanceSq(newPoint) != 0) {
//		node.setOffset(newPoint);
//		}

		Object o = shapeToObjectMap.get(node);

		LatLon latlon=null;
		try{
			latlon = WWUtils.CoordToLatLon(geography.getGeometry(o).getCoordinate());
		}
		catch(Exception e){
			e.printStackTrace();
		}

//		List<LatLon> list = new ArrayList<LatLon>();
//		list.add(pos);
//		node.setPositions(list);

//		((SurfaceShape)node).moveTo(new Position(latlon,0));
		
//		((WWSphereFERAL)node).setLatlon(latlon);

	}

	public Geography getGeography() {
		return geography;
	}

	public void setGeography(Geography geography) {
		this.geography = geography;
	}

	public boolean isPopulation() {
		return population;
	}

	public void setPopulation(boolean population) {
		this.population = population;
	}
}
